=== modified file '.bzrignore'
--- .bzrignore	2009-06-03 14:59:46 +0000
+++ .bzrignore	2009-06-03 20:30:50 +0000
@@ -1,7 +1,16 @@
+Makefile
+Makefile.in
+Makefile.in.in
+POTFILES
 build
 dist
 _trial_temp
+libtool
+ltmain.sh
+stamp-it
+*.gmo
+*.la
+*.lo
 *_pb2.py
 *.pot
 *.pyc
-

=== modified file 'Makefile.am'
--- Makefile.am	2009-05-30 12:08:32 +0000
+++ Makefile.am	2009-06-03 20:30:50 +0000
@@ -1,4 +1,4 @@
-SUBDIRS = po
+SUBDIRS = nautilus po
 
 MAINTAINERCLEANFILES =			\
 	Makefile.in			\

=== modified file 'configure.ac'
--- configure.ac	2009-05-30 12:08:32 +0000
+++ configure.ac	2009-06-03 20:30:50 +0000
@@ -9,6 +9,7 @@
 
 AC_ISC_POSIX
 AC_PROG_CC
+AC_PROG_LIBTOOL
 IT_PROG_INTLTOOL([0.40.0])
 
 GETTEXT_PACKAGE="${PACKAGE}"
@@ -19,6 +20,10 @@
 localedir='${prefix}/${DATADIRNAME}/locale'
 AC_SUBST(localedir)
 
+PKG_CHECK_MODULES(NAUTILUS, [libnautilus-extension >= 2.6.0])
+AC_SUBST(NAUTILUS_CFLAGS)
+AC_SUBST(NAUTILUS_LIBS)
+
 PKG_CHECK_MODULES(DBUS, [dbus-glib-1 >= 0.70])
 AC_SUBST(DBUS_CFLAGS)
 AC_SUBST(DBUS_LIBS)
@@ -39,8 +44,8 @@
 
 AC_CONFIG_FILES([
 Makefile
+nautilus/Makefile
 po/Makefile.in
 ])
 
 AC_OUTPUT
-

=== added file 'nautilus/Makefile.am'
--- nautilus/Makefile.am	1970-01-01 00:00:00 +0000
+++ nautilus/Makefile.am	2009-06-03 20:30:50 +0000
@@ -0,0 +1,21 @@
+
+extensiondir = $(libdir)/nautilus/extensions-2.0
+
+extension_LTLIBRARIES = libnautilus-ubuntuone.la
+
+libnautilus_ubuntuone_la_CFLAGS =			\
+	-DG_LOG_DOMAIN=\"UbuntuOne-Nautilus\"		\
+	-DGNOMELOCALEDIR=\""$(datadir)/locale"\"	\
+	$(DBUS_CFLAGS)					\
+	$(NAUTILUS_CFLAGS)
+
+libnautilus_ubuntuone_la_SOURCES =	\
+	ubuntuone-nautilus.c
+
+libnautilus_ubuntuone_la_LDFLAGS = -no-undefined -avoid-version
+libnautilus_ubuntuone_la_LIBADD  =	\
+	$(DBUS_LIBS)			\
+	$(NAUTILUS_LIBS)
+
+MAINTAINERCLEANFILES =	\
+	Makefile.in

=== added file 'nautilus/ubuntuone-nautilus.c'
--- nautilus/ubuntuone-nautilus.c	1970-01-01 00:00:00 +0000
+++ nautilus/ubuntuone-nautilus.c	2009-06-03 20:30:50 +0000
@@ -0,0 +1,137 @@
+/*
+ * ubuntuone-nautilus.c - Nautilus extensions for Ubuntu One
+ *
+ * Authors: Tim Cole <tim.cole@canonical.com>
+ *          Rodney Dawes <rodney.dawes@canonical.com>
+ *
+ * Copyright 2009 Canonical Ltd.
+ *
+ * This program is free software: you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 3, as published
+ * by the Free Software Foundation.
+ *
+ * This program is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranties of
+ * MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR
+ * PURPOSE.  See the GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License along
+ * with this program.  If not, see <http://www.gnu.org/licenses/>.
+ *
+ */
+
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include <libnautilus-extension/nautilus-extension-types.h>
+#include <libnautilus-extension/nautilus-column-provider.h>
+#include <libnautilus-extension/nautilus-file-info.h>
+#include <libnautilus-extension/nautilus-info-provider.h>
+#include <libnautilus-extension/nautilus-menu-provider.h>
+#include <libnautilus-extension/nautilus-property-page-provider.h>
+
+#define UBUNTUONE_TYPE_NAUTILUS  (ubuntuone_nautilus_get_type ())
+#define UBUNTUONE_NAUTILUS(o)    (G_TYPE_CHECK_INSTANCE_CAST ((o), UBUNTUONE_TYPE_NAUTILUS, UbuntuOneNautilus))
+
+typedef struct {
+  GObject parent_slot;
+} UbuntuOneNautilus;
+
+typedef struct {
+  GObjectClass parent_slot;
+} UbuntuOneNautilusClass;
+
+static GType ubuntuone_nautilus_get_type (void);
+static void ubuntuone_nautilus_register_type (GTypeModule * module);
+
+static GObjectClass * parent_class = NULL;
+
+/* Update file info provider */
+static NautilusOperationResult ubuntuone_nautilus_update_file_info (NautilusInfoProvider * provider,
+								    NautilusFileInfo * file,
+								    GClosure * update_complete,
+								    NautilusOperationHandle ** handle) {
+  gchar *share_status = NULL;
+  char * path = NULL;
+  int size = 0, ret = 0;
+
+  path = g_filename_from_uri (nautilus_file_info_get_uri (file), NULL, NULL);
+
+  return NAUTILUS_OPERATION_COMPLETE;
+}
+
+static void ubuntuone_nautilus_info_provider_iface_init (NautilusInfoProviderIface * iface) {
+  iface->update_file_info = ubuntuone_nautilus_update_file_info;
+}
+
+
+/* GType and nautilus module stuff */
+static GType un_type = 0;
+
+static void ubuntuone_nautilus_instance_init (UbuntuOneNautilus * epn) {
+}
+
+static void ubuntuone_nautilus_class_init (UbuntuOneNautilusClass * klass) {
+	parent_class = g_type_class_peek_parent (klass);
+}
+
+static GType ubuntuone_nautilus_get_type (void) {
+  return un_type;
+}
+
+static void ubuntuone_nautilus_register_type (GTypeModule * module) {
+  static const GTypeInfo info = {
+    sizeof (UbuntuOneNautilusClass),
+    (GBaseInitFunc) NULL,
+    (GBaseFinalizeFunc) NULL,
+    (GClassInitFunc) ubuntuone_nautilus_class_init,
+    NULL,
+    NULL,
+    sizeof (UbuntuOneNautilus),
+    0,
+    (GInstanceInitFunc) ubuntuone_nautilus_instance_init,
+  };
+
+  static const GInterfaceInfo info_provider_iface_info = {
+    (GInterfaceInitFunc) ubuntuone_nautilus_info_provider_iface_init,
+    NULL,
+    NULL
+  };
+  
+  un_type = g_type_module_register_type (module, 
+					 G_TYPE_OBJECT,
+					 "UbuntuOneNautilus",
+					 &info, 0);
+  
+  g_type_module_add_interface (module,
+			       un_type,
+			       NAUTILUS_TYPE_INFO_PROVIDER,
+			       &info_provider_iface_info);
+}
+
+
+/* Required Nautilus module handling methods */
+void nautilus_module_initialize (GTypeModule * module) {
+#ifdef ENABLE_NLS
+  bindtextdomain (GETTEXT_PACKAGE, GNOMELOCALEDIR);
+  bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
+  textdomain (GETTEXT_PACKAGE);
+#endif
+
+  ubuntuone_nautilus_register_type (module);
+}
+
+void nautilus_module_shutdown (void) {
+}
+
+
+void nautilus_module_list_types (const GType ** types,
+				 int * num_types) {
+  static GType type_list[1];
+  
+  type_list[0] = UBUNTUONE_TYPE_NAUTILUS;
+
+  *types = type_list;
+  *num_types = 1;
+}

